#include <iostream>
#include <stdio.h>
using namespace std;

int main()
{   long long int m,n,c,c1=1,u=0,ost;
    scanf("%lld%lld",&n,&m);
    long long int B[m];
    for(int i=1;i<=m;i++)
    {
        long long int x;
        scanf("%lld",&x);
        B[i]=x;
    }
    scanf("%lld",&c);
    long long int A[n];
    for (int i=0; i<n; i++)
        A[i]=i+1;
    for(int i=0; i<=n-m; i++)
    {
        for (int j=1; j<=m; j++)
            A[i + B[j]] = A[i + j];
    }
    for(int j=1; j<=n; j++)
    {
        for(int i=1 ; i<=j; i++)
        {
            c1=c1*c;
        }
        u=u+c1*A[j];
        c1=1;
    }
    ost=u%998244353;
    printf("%lld\n",ost);
    return 0;
}